#ifndef _INDEX_H
#define _INDEX_H
#include "aesanode.h"
#include "interface.h"

class CAESAIndex :public CInterface {
  protected:
    CAESANode node;
  public:
    CAESAIndex  (bool hasTransp, EAlphabet );
    ~CAESAIndex  ();
    bool opened;
    int fd;

    //=========================================================================
    bool Insert (const char *str);
    bool InsertList (const StringList & lst);
    bool Search (const char *str, int kerr, int *numComp,
                 StringList * resList, bool silent = true);
    //=========================================================================
    bool SearchInDB (const char *str, int kerr, int *numComp,
                     StringList * resList, bool silent = true);
    //=========================================================================
    bool DumpDB (const char *file_name);
    bool OpenDB (const char *file_name, bool create = false);
    bool CreateInMemIndex(const char *inputFile, int insertCount, int *dcnt, bool silent = true);
    bool CloseDB ();
    void Print ();
};

template <>
inline bool SearchDbNotSupported<CAESAIndex>() {
    return true;
}

#endif
