#ifndef _INDEX
#define _INDEX


#include <stdlib.h>
#include <vector>
#include <algorithm>
#include <string>
#include <iostream>
#include <fcntl.h>
#include <errno.h>
#include <fstream>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <set>
#include <list>
#include "interface.h"
#include "onedel.h"
#include "../Common/hash.h"

using namespace std;

class CSpellIndex:public CInterface {

  public:
    CSpellIndex (bool hasTransp, EAlphabet AlphaType);
    virtual ~CSpellIndex ();
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true) {
        cerr << "SearchInDB is not supported";
        return true;
    }
    virtual bool DumpDB (const char *base_name);
    virtual bool OpenDB (const char *base_name, bool create = false);
    virtual bool CloseDB ();

    typedef StringHashSet StringSet;
  protected:
    COneDelIndex  mSpellIndex;
    char          *ABC;
    bool          opened;
    void ExpandAndSearch(StringHashSet& hGenerated, 
                        int start, int &numComp, string & str, int kerr, 
                        StringList *resList,
                        bool    bFullExpansion);
    int  fdDict;
    int  fdHash;
    int  fdParams;
    char    *pDict;
    size_t  *pHash;
    CHashParams  *pParams;

    bool mapData();
    void unmapData();
};

template <>
inline bool SearchDbNotSupported<CSpellIndex>() {
    return true;
}

#endif
