#ifndef _INDEX
#define _INDEX


#include <stdlib.h>
#include <vector>
#include <algorithm>
#include <string>
#include <iostream>
#include <fcntl.h>
#include <errno.h>
#include <fstream>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <set>
#include <list>
#include "interface.h"
#include "../Common/hash.h"

using namespace std;

class CSpellIndex:public CInterface {

  public:
    CSpellIndex (bool hasTransp, EAlphabet );
    virtual ~ CSpellIndex ();
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true);
    virtual bool DumpDB (const char *base_name);
    virtual bool OpenDB (const char *base_name, bool create = false);
    virtual bool CloseDB ();

    typedef StringHashSet StringSet;
  protected:
    char *ABC;

    StringSet Dict;
    bool opened;

    int  fdDict;
    int  fdHash;
    int  fdParams;
#ifndef USE_CHAIN_HASH
    char   *pDict;
    size_t *pHash; 
    CHashParams *pParams;
#else
    struct Params {
        size_t bucketNum;
        size_t dictSize;
        Params(size_t bucketNum = 0, size_t dictSize = 0) 
            : bucketNum(bucketNum), dictSize(dictSize) {
            }
    };
    struct Bucket {
        size_t offset;
        size_t num;
        Bucket(size_t offset = 0, size_t num = 0) : offset(offset), num(num) {}
    };
    char    *pDict;
    Bucket  *pHash;
    Params  *pParams;
#endif

    bool mapData();
    void unmapData();

    bool searchHashDB(const string & str); // returns true if found
};

#endif
