#ifndef ALTERN_REDALPHA_MORFRANK_H
#define ALTERN_REDALPHA_MORFRANK_H

#include "interface.h"
#include <fcntl.h>
#include <iostream>

#include "../AlternGenReducedAlpha/index.h"
#include "../Common/gendel.h"

typedef hash_map<unsigned, StringList> Unsigned2StringList;

class CAlternGenRedAlphaMorFrank : public CInterface {
public:
     CAlternGenRedAlphaMorFrank(bool hasTransp, EAlphabet AlphaType);
    ~CAlternGenRedAlphaMorFrank() {
        for (unsigned i = 0; i < sizeof(mapHashTable)/sizeof(*mapHashTable); ++i) {
            delete [] mapHashTable[i];
            delete [] mapHashContent[i];
        }
    }

    bool CreateInMemIndex(const char *inputFile,
                             int insertCount, int *dcnt, 
                             bool silent = true);
    //=========================================================================
    bool Insert(const char *str);
    bool Search(const char *str, int kerr, int *numComp,
                 StringList * resList, bool silent = true);
    //=========================================================================
    bool SearchInDB(const char *str, int kerr, int *numComp,
                    StringList * resList, bool silent = true) {
        cerr << "SearchInDB is not supported" << endl;
        return false;
    }
    //=========================================================================
    bool DumpDB (const char *base_name);
    bool OpenDB (const char *base_name, bool create = false);
    bool CloseDB ();
    void PrintAddStat(SearchType type, int testNum, int kerr, ostream &);
#ifdef _DEBUG
    void Print ();
#endif
private:
    CAlternGenRedAlpha  mRedHash;
    bool                mbOpened;

    string TmpChunkName(unsigned kerr, unsigned ChunkNum) {
        stringstream fn;

        fn << "TmpChunk_K=" << kerr << "_Chunk=" << ChunkNum;

        return fn.str();
    }
    unsigned char*  mapHashContent[MAX_KERR + 1];
    size_t*         mapHashTable[MAX_KERR + 1];
    size_t          maTableSize[MAX_KERR + 1];
};

template <>
inline bool SearchDbNotSupported<CAlternGenRedAlphaMorFrank>() {
    return true;
}

#endif
