#ifndef ADD_COMBINED_KETS_H
#define ADD_COMBINED_KETS_H

#include <sys/types.h>
#include <string.h>

#include <iostream>
#include <algorithm>

#include "addtrieinfo.h"

class CAddCombinedKetsAllocator {
public:
    static CAddCombinedKets* AllocKets(SmallCounter Qty, const COneKetPrime *pKets = NULL) { 
        size_t              sz = KetSize(Qty);
        CAddCombinedKets*   p = reinterpret_cast<CAddCombinedKets*>(new char[sz]);

        mUsedMem += sz;

        if (pKets) {
            memcpy(p->mpKetArr, pKets, Qty * sizeof *pKets);
        } else {
            memset(p->mpKetArr, 0, Qty * sizeof *pKets);
        }

        p->mQty = Qty;

        return p;
    }

    static CAddCombinedKets* AddKetReallocMem(CAddCombinedKets* pOldKets, const COneKetPrime& AddKet) { 
        SmallCounter        OldQty   = pOldKets->GetQty();
        CAddCombinedKets*   pNewKets = AllocKets(OldQty + 1);

        memcpy(pNewKets->mpKetArr, pOldKets->mpKetArr, OldQty * sizeof AddKet);
        pNewKets->mpKetArr[OldQty] = AddKet;

        FreeKets(pOldKets);

        return pNewKets;
    }

    static void              FreeKets(CAddCombinedKets* p) { 
        if (!p) { return; }
        mUsedMem -= KetSize(p->GetQty());
        delete [] reinterpret_cast<char *>(p);
    }
    static size_t GetTotalMemUsed() { return mUsedMem; }
private:
    static size_t KetSize(SmallCounter Qty) { return sizeof(CAddCombinedKets) + sizeof(COneKetPrime) * Qty; }
    static size_t  mUsedMem;
};



#endif
