#ifndef ADD_TRIE_INFO_H
#define ADD_TRIE_INFO_H

#include "nodehelper.h"

struct COneKetPrime {
    NodeIndex       mKetPrime; // An array of KET'
    SmallCounter    mStartLevel;
    COneKetPrime(NodeIndex KetPrime = 0, SmallCounter  StartLevel = 0) : mKetPrime(KetPrime), mStartLevel(StartLevel) {}
}
#ifdef __GNUC__ 
__attribute__ ((packed))
#endif
;

struct CAddCombinedKets {

    CAddCombinedKets(SmallCounter Qty = 0) : mQty(Qty) {}
    SmallCounter        GetQty() const { return mQty; }
    const COneKetPrime* GetKetArr() const { return (mQty) ? mpKetArr:NULL; } 
    COneKetPrime* GetKetArr() { return (mQty) ? mpKetArr:NULL; } 

protected:
    SmallCounter          mQty;
    COneKetPrime          mpKetArr[0];

    friend class CAddCombinedKetsAllocator;
}
#ifdef __GNUC__ 
__attribute__ ((packed))
#endif
;

/* 
 * This information is needed to
 * support k-errata tree, which includes
 * centroid path decomposition.
 */

struct CAddNodeInfo {
    NodeIndex       mLeafQty;         // If it is zero, then it is not calculated yet.
    NodeIndex       mKetSubstInsTrie; // Substitution and Insertion, off-path subtrees merged together (transposition TODO/TBD).
    NodeIndex       mKetDelTrie;      // Deletion off-path subtrees merged together
    SmallCounter    mCentroid;
    bool            mHasCentroid;
    bool    IsKetSubstInsEmpty() const { return mKetSubstInsTrie == NILL_NODE_INDEX; }
    bool    IsKetDelEmpty() const      { return mKetDelTrie == NILL_NODE_INDEX; }
    CAddNodeInfo() : mLeafQty(0), mKetSubstInsTrie(NILL_NODE_INDEX), mKetDelTrie(NILL_NODE_INDEX), mCentroid(0), mHasCentroid(false) {}
}
#ifdef __GNUC__ 
__attribute__ ((packed))
#endif
;



#endif
