#include "testcole.h"
#include "testutil.h"

using namespace std;

typedef vector<string> vs;

bool
TestBasic(int MinLen, int MaxLen, size_t NumStr, int kerr, bool bHasTransp)
{
    vs  StrList;

    GenRandStringList(MinLen, MaxLen, true, NumStr, StrList);

    CErrataTree     ErrataTree;

    ErrataTree.Create(StrList, kerr, bHasTransp);
}


bool 
TestBasicSearch(const std::vector<std::string>& vDictList, const std::vector<std::string>& vSearchList, int kerr, bool bHasTransp)
{
    CErrataTree     ErrataTree;

    ErrataTree.Create(vDictList, kerr, bHasTransp);

    ErrataTree.PrintMainTrie(); 

    for (int i = 0; i < vSearchList.size(); ++i) {
        vs ResultList;

        ErrataTree.Search(vSearchList[i], kerr, &ResultList);
        cout << "Search for '" << vSearchList[i] << "' with " << kerr << " errors" << endl;
        cout << "Found strings:" << endl;
        for (int k = 0; k < ResultList.size(); ++k) {
            cout << ResultList[k] << endl;
        }
    }

    return true;
}

