#include <iostream>
#include <iomanip>

#include "testcole.h"

#include "../Common/mytest.h"

using namespace std;

typedef vector<string> vs;

bool
BasicSearch2(bool bHasTransp)
{

    const char* vpDict[] = {
        "abcdef",
    };

    const char* vpPattern[] = {
        "cdef",// To check if KET' trie is working
    };

    size_t DictLen = sizeof vpDict / sizeof *vpDict; 
    size_t PatLen = sizeof vpPattern / sizeof *vpPattern; 

    for (int kerr = 1; kerr <= 2; ++kerr) {
        TEST_COND_MSG_RETURN_FALSE(TestBasicSearch(vs(vpDict, vpDict +  DictLen), vs(vpPattern, vpPattern + PatLen), kerr, bHasTransp), "TestBasicSearch failed")
    }

    return true;
}

bool
BasicSearch1(bool bHasTransp)
{

    const char* vpDict[] = {
        "abcdef",
        "abcxyz",
        "abcxa",
        "abcxb",
        "abcxc",
        "abcde",
        "bolt",
        "bort",
        "bortify",
        "bortifyent",
        "acidic",
        "acdc",
        "bozz",
    };

    const char* vpPattern[] = {
        "borzz",// To check if KET' trie is working
        "bot",  // Should match two strings (one along centroid path, another in KET trie)
        "boxrt",
        "bolt", // Should match two strings for kerr == 1
        "boz",
        "boltr",
        "rbcdef",
        "arcdef",
        "abcref",
        "rbolt",
        "rbort",
        "bacdex",
        "acbdex",
        "xbdcef",
        "xcedf",
        "xbcdfe",
    };

    size_t DictLen = sizeof vpDict / sizeof *vpDict; 
    size_t PatLen = sizeof vpPattern / sizeof *vpPattern; 

    for (int kerr = 1; kerr <= 2; ++kerr) {
        TEST_COND_MSG_RETURN_FALSE(TestBasicSearch(vs(vpDict, vpDict +  DictLen), vs(vpPattern, vpPattern + PatLen), kerr, bHasTransp), "TestBasicSearchFailed")
    }

    return true;
}


bool
BasicTestNoTransp()
{
    int kerr = 1;
    return TestBasic(1, 10, 32, kerr, false);
}



bool
BasicTestNoTransp20()
{
    int kerr = 1;

    return TestBasic(1, 10, 1024 * 64, kerr, false);
}

int main(int argc, char* pArgv[]) {
    int nFail = 0, nTest = 0;

    for (unsigned HasTransp = 1; HasTransp < 2; ++HasTransp) {
        //TEST_NO_FAIL(BasicSearch2(HasTransp != 0), nFail, nTest);
        TEST_NO_FAIL(BasicSearch1(HasTransp != 0), nFail, nTest);
    }
    //TEST_NO_FAIL(BasicTestNoTransp(), nFail, nTest);
    //TEST_NO_FAIL(BasicTestNoTransp20(), nFail, nTest);

    cout << nTest << " test(s) performed, " << nFail << " test(s) failed." << endl;

    return nFail;
}
