#ifndef GENDEL_H
#define GENDEL_H

#include "myexcept.h"

template <class T>
void GenAllDeletions(string s, unsigned kMin, unsigned kMax, T& RecvObj) {
    char            aCurrChar[kMax];
    unsigned char   aPos[kMax];

    size_t   uSize = s.size();

    if (uSize > 254) {
        THROW_AND_PRINT_RUNTIME_ERROR("Words longer than 254 chars are not supported");
    }

    fill(aCurrChar, aCurrChar + kMax, 0);

    for (unsigned k = kMin; k <= kMax; ++k) {
        if (uSize < k) continue; // String is too small to "survive" k deletions

        fill(aPos, aPos + k, 0);
        fill(aPos + k, aPos + kMax, 255);

        // TODO/TBD it is not the most efficient way to generate k deletions
        bool fNext = true;
        while (fNext) {
            // Do erase
            for (unsigned j = 0; j < k; ++j) {
                aCurrChar[j] = s[aPos[j]];
                s.erase(aPos[j], 1);
            }
            // Do output
            RecvObj(s, aPos, aCurrChar, kMax);


            // Do insert
            for (unsigned j = k; j; --j) {
                s.insert(s.begin() + aPos[j - 1], aCurrChar[j - 1]);
            }
            // Increment
            fNext = false;
            for (unsigned ks = k; ks; --ks) {
                if (aPos[ks - 1] + 1 <= uSize - k) {
                    ++aPos[ks - 1];
                    fNext = true;   
                    for (unsigned j = ks; j < k; ++j) aPos[j] = aPos[ks - 1];
                    break;
                }
            }
        }
    }
}

#endif
