#ifndef HASH_H
#define HASH_H

#include <algorithm>
#include <string>

#define SKIP_CONSTANT 131071

// Note: assumes long is at least 32 bits.
enum { from__stl_num_primes = 28 };

extern const unsigned long from__stl_prime_list[];

inline unsigned long from__stl_next_prime(unsigned long __n)
{
  const unsigned long* __first = from__stl_prime_list;
  const unsigned long* __last = from__stl_prime_list + (int)from__stl_num_primes;
  const unsigned long* pos = std::lower_bound(__first, __last, __n);
  return pos == __last ? *(__last - 1) : *pos;
}

struct CHashParams {
    size_t fillRatio; // from minHashRatio to maxHashRation in percents
    size_t hashSize;
    size_t dictSize;
    CHashParams(size_t fillRatio = 0, size_t hashSize = 0, size_t dictSize = 0) 
        : fillRatio(fillRatio), hashSize(hashSize), dictSize(dictSize) {
        }
};

bool insertHashDB(const std::string &str, size_t &buckNum,  const CHashParams&, size_t* pHash, long long* pSeekVal = NULL);

#endif
