#ifndef _INDEX
#define _INDEX

#include "search.h"
#include "db.h"



class Index {
  protected:
    static int ncnt;
    static int mcnt;
    static int pagesize;
    static char *progname;
    static int cachesize;
    //-------- File attributes & db attributes
    DB *dbp;
    DBC *dbcp;
    DB_ENV *dbenv;
    DB_INFO dbinfo;
    FILE *fdata;                //open readonly
    bool opened;
    void Error (const char *str);
    DB_ENV *db_init (char *);
  public:
     Index ();
    ~Index ();
    static const int Ncnt () {
        return Index::ncnt;
    }
    //--------- Opening/creating ------
        bool Open (const char *dbname, const char *dataname);
    bool Create (const char *dbname, const char *dataname);
    bool IsOpen ();
    bool Close ();
    bool ParseDataFile ();
    //--------- Searching/inserting ---
    bool Insert (char *str, off_t addr, int8 len);
    bool InsertPtr (char *ngram, int8 len, off_t addr, int8 len);
    bool Search (const char *str, unsigned int errnum, bool Sub = false);
    bool SeqSearch (const char *str, unsigned int errnum, bool Sub =
                    false);

};

#endif
