#include <utils.h>
#include <assert.h>
#include <iostream>
#include <string>
#include "myexcept.h"

using namespace std;

void Perror (std::string s)
{
    Perror (s.c_str ());
}

void Perror (const char * str)
{
    cerr << ((str != NULL) ? string (str) +
             ":" : "") << strerror (errno) << endl;
}

char *newstrdup (const char *pstr)
{
    int len = strlen (pstr);
    char *dest = new char[len + 1];
    strncpy (dest, pstr, len + 1);
    dest[len] = 0;
#ifdef _DEBUG
    assert (!strcmp (pstr, dest));
#endif
    return dest;
}

bool GetEnvSwitch(const char *pName)
{
    if (!pName) return false;
    const char *p = getenv(pName);
    return p && atol(p);
}

bool GetEnv(const char *pName, int & val)
{
    if (!pName) return false;
    const char *p = getenv(pName);
    if (p) {
        val = atol(p);
        return true;
    }
    return false;
}

bool GetEnv(const char *pName, std::string & val)
{
    if (!pName) return false;
    const char *p = getenv(pName);
    if (p) {
        val = p;
        return true;
    }
    return false;
}

off_t   LseekThrowOnErr(int fd, off_t offset, int whence)
{
    errno = 0;
    off_t res = lseek(fd, offset, whence);

    if (res == off_t(-1)) {
        Perror("lseek failed");
        THROW_AND_PRINT_RUNTIME_ERROR("Cannot lseek!");
    }
    return res;
}
