
#include "obj.h"

typedef void *Index;

	/* creates and returns a structure for the first n elements of 
	   database dbname (all if n=0). other construction parameters come 
	   in argc and argv, which should be used and modified accordingly.
	   this operation must open the database */
Index build (char *dbname, int n, int *argc, char ***argv);

	/* frees the index; and closes the database if closedb */
void freeIndex (Index S, bool closedb);

	/* stores it in fname (can be a file, or directory, or set of files).
 	   it must stode the database name, as it is not given for loading */
void saveIndex (Index S, char *fname);

	/* reads an index from fname, and also opens the DB */
Index loadIndex (char *fname);

	/* range search for query obj with radius r in index S. it returns
	   how many objects it found. it prints them if show */
int search (Index S, Obj obj, Tdist r, bool show);

	/* idem, but the k closest are sought and it returns the distance to
	   the farthest */
Tdist searchNN (Index S, Obj obj, int k, bool show);

