#ifndef FAST_SS_WRAPPER_H
#define FAST_SS_WRAPPER_H

#include "interface.h"
#include <fcntl.h>
#include <iostream>
#include <vector>
#include <string>

class CFastSSWrapper : public CInterface {
public:
    CFastSSWrapper(bool hasTransp, EAlphabet AlphaType);
    virtual ~CFastSSWrapper();

    bool CreateInMemIndex(const char *inputFile,
                             int insertCount, int *dcnt, 
                             bool silent = true);
    //=========================================================================
    bool Insert(const char *str);
    bool Search(const char *str, int kerr, int *numComp,
                 StringList * resList, bool silent = true);
    //=========================================================================
    bool SearchInDB(const char *str, int kerr, int *numComp,
                    StringList * resList, bool silent = true) {
        cerr << "SearchInDB is not supported" << endl;
        return false;
    }
    //=========================================================================
    bool DumpDB (const char *base_name);
    bool OpenDB (const char *base_name, bool create = false);
    bool CloseDB ();

private:
    void*   mpIndex;
};

template <>
inline bool SearchDbNotSupported<CFastSSWrapper>() {
    return true;
}


#endif
