#include "interface.h"
#include "alphabet.h"
#include "langcase.h"

#include <iostream>

using namespace std;

void Usage(const char* p){ 
    cerr << "Usage: <alphabet type> <string> <kerr>" << endl;
    cerr << "Alphabet type: eng, rus, engnum, engshort, dna" << endl;
}

void ToLower(string& str) {
    for (unsigned j = 0; j < str.size(); ++j) {
        str[j] = tolower_eng_rus(str[j]);
    }
};


int main(int argc, char *pArgv[]) {
    if (argc < 4) {
        Usage(pArgv[0]);
        return 1;
    }
    StringList  lst;
    bool        bHasTransp = false;; 
    int         kerr = atoi(pArgv[3]);
    EAlphabet   type = GetAlphabetType(pArgv[1]);
    const char* pABC = GetAlphabet(type);
    if (!pABC) {
        cerr << "Wrong alphabet type" << endl;
        Usage(pArgv[0]);
        return 1;
    }
    string      str = pArgv[2];
    ToLower(str);

    FillExpansionList (str, bHasTransp, kerr, &lst, pABC, kerr, false, 0, false);

    int NG = 0;
    for (unsigned i = 0; i < lst.size(); ++i) {
        ToLower(lst[i]);
        ++NG;
        cout << lst[i] << endl;
    }

    return 0;
};
