#ifndef _INDEX
#define _INDEX

#include <stdexcept>

#include "interface.h"
#include "utils.h"
#include "myexcept.h"

#include <stringmap/src/stringmap.h>

#define SAMPLE_PCT 0.1

class CFlamingoMtreeIndex : public CInterface {
  public:
   protected:
    vector<string>          mvList;
    float                   maThreshold[MAX_KERR + 1];
    StringMap*              mpStrMap;
  public:
    CFlamingoMtreeIndex(bool hasTransp, EAlphabet AlphaType);
    virtual ~CFlamingoMtreeIndex();
    //=========================================================================
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true);
    //=========================================================================
    bool CreateInMemIndex (const char * inputFile, int insertCount, int * dcnt, bool silent = true);
    virtual bool DumpDB (const char *base_name);
    virtual bool OpenDB (const char *base_name, bool create = false);
    bool CloseDB ();
#ifdef _DEBUG
    void Print (){}
#endif
}

;

#endif
