
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

#define ulong unsigned long

#define free(p) { if ((p) != 0) free(p); }
#define malloc(n)    ((n) == 0 ? 0 : malloc(n))
#define realloc(p,n) ((p) == NULL ? malloc(n) : realloc(p,n))

#define CTRL(p) { if ((p)==NULL) { fprintf (stderr,"out of memory\n"); exit(1); }}

typedef unsigned char byte;

static void step (register byte *c, int m, int k, 
		  register byte *p, register byte cc)

    { register int pc,nc,j,lcol;
      pc = 0; nc = 1; lcol = c[0];
      for (j=1;j<=lcol;j++)
         { if (c[j] < nc) nc = c[j];
           pc += (cc != p[j]);
           if (pc <= nc) nc = pc; else nc++;
           pc = c[j]; c[j] = nc;
         }
      /* Watch out for k, it can be zero! */
      while (lcol && c[lcol] > k) lcol--;
      if (lcol < m) c[++lcol] = k+1;
      c[0] = lcol;
    }

typedef struct
   { void *(h[3]);
   } tnodes;

typedef tnodes *trie;
   
trie tcreate (int m)
   { trie t;
     int i;
     CTRL(t = (trie)malloc(m*sizeof(tnodes))); 
     for (i=0;i<m;i++) t[i].h[0] = t[i].h[1] = t[i].h[2] = NULL;
     return t;
   }

int igual (register byte *c1, register byte *c2)
   { register int i = c1[0];
     for (i=c1[0];i>=0;i--) if (c1[i] != c2[i]) return 0;
     return 1;
   }

typedef struct
   { byte *c;
     int *vec;
     int f;
   } nodo;

typedef struct
   { nodo *nodos;
     ulong size;
     byte S[256];
     int psigma;
     byte *sigma;
   } grafo;

int tadd (trie t, byte **c, int k, int m, grafo *G)
   { int j,pc,nstate;
     tnodes *tn;
     nodo *N;
     int lim,pos = 0;
     int new = 0;
     j = 1; pc = 0;
     lim = **c; if (lim < m) lim--;
     tn = &t[**c-1];
     for (j=1;j <= lim;j++)
	{ pos = (*c)[j]-pc+1; 
	  pc = (*c)[j];
          if (j < lim)
	     { if (tn->h[pos] == NULL)
	           { CTRL(tn->h[pos] = (void*)malloc (sizeof(tnodes)));
	             ((trie)tn->h[pos])->h[0] = 
	             ((trie)tn->h[pos])->h[1] = 
	             ((trie)tn->h[pos])->h[2] = NULL;
	             new = 1;
		   }
	       tn = tn->h[pos];
	     }
          else 
	     { if (!new && (tn->h[pos] != (void*)0))
                  return ((int)tn->h[pos])-1;
	     }
	}
     nstate = G->size;
     tn->h[pos] = (void*)nstate+1;
     if ((G->size % 50) == 0)
        CTRL(G->nodos = (nodo*) realloc (G->nodos, 
					 (G->size+50) * sizeof(nodo))); 
     G->size++;
     N = &G->nodos[nstate];
     N->c = *c; *c = NULL;
     CTRL(N->vec = (int*)malloc (G->psigma*sizeof(int)));
     for (j=0;j<G->psigma;j++) N->vec[j] = -1;
     N->f = (N->c[N->c[0]] <= k);
     return nstate;
   }

trie T;
grafo G;
int m,k;
byte *pat;
byte *C;

void mkautom (void)

   { int i,j;

     for (i=0;i<256;i++) G.S[i] = 0;
     for (i=0;i<=m;i++) G.S[pat[i]]=1;
     G.psigma = 0; for (i=0;i<256;i++) G.psigma += G.S[i];
     CTRL(G.sigma = (byte*) malloc (G.psigma));
     G.psigma = 0; 
     for (i=0;i<256;i++) 
	if (G.S[i]) { G.S[i] = G.psigma; G.sigma[G.psigma++] = i; }

     CTRL(C = (byte*) malloc (m+1));
     C[0] = k+1;
     for (i=1;i<=k+1;i++) C[i] = i;
     T = tcreate(m);
     G.nodos = NULL; G.size = 0;
     tadd (T,&C,k,m,&G);
     CTRL(C = (byte*) malloc (m+1)); 
   }

int expand (int state, int pos)

   { int nstate;
     nodo *N = &G.nodos[state];
     memcpy (C,N->c,N->c[0]+1);
     step (C,m,k,pat,G.sigma[pos]);
     nstate = G.nodos[state].vec[pos] = tadd (T,&C,k,m,&G);
     if (C == NULL) CTRL(C = (byte*) malloc (m+1)); 
     return nstate;
   }

int main (int argc, char **argv)

   { int n,pos;
     byte *text;
     register byte *ptr;
     struct stat st;
     int matches;
     FILE *f;
     register int state,nstate;
     if (argc != 4)
	{ fprintf (stderr,"usage: %s <pat> k <file>\n",argv[0]);
	  exit(1);
	}
     pat = argv[1];
     m = strlen(pat); k = atoi(argv[2]);
     mkautom ();
     pat--;

     if (stat (argv[3],&st) != 0) { fprintf (stderr,"%s not found\n",argv[3]); exit(1); }
     n = st.st_size;
     CTRL (text = (byte*)malloc (n+1));
     f = fopen (argv[3],"r");
     fread (text,n,1,f);
     fclose (f);
     text[n] = 0;
     state=0; matches = 0;
     
     for (ptr=text;*ptr;ptr++)
	{ pos = G.S[*ptr];
	  nstate = G.nodos[state].vec[pos];
	  state = (nstate != -1) ? nstate : expand (state,pos);
	  if (G.nodos[state].f) {
            matches++;
	    if (1) { byte *p;
	       /* printf ("%i: ...",i); */
	       p = ptr-10; if (p<text) p=text;
	       while (p<ptr) putchar(*p++);
	       printf ("\n");
	     }
           }
	}
     printf ("%i estados\n",G.size);
     printf ("%i matches\n",matches);
     exit(0);
   }
