#include "index.h"

#include <fstream>

CFlamingoNgramIndex::CFlamingoNgramIndex (bool hasTransp, EAlphabet AlphaType): CInterface(hasTransp, AlphaType), NgramLen(4), mpWrap(NULL), mStrContVect(true)
{
    GetEnv("NGRAM_LEN", NgramLen);
    cout << "Qgram size: " << NgramLen << endl;
    
    mpGramGen = new GramGenFixedLen(NgramLen);
    mStrContVect.initStatsCollector(mpGramGen);
}

CFlamingoNgramIndex::~CFlamingoNgramIndex () {
    delete mpGramGen;
    delete mpWrap;
}

bool CFlamingoNgramIndex::Insert (const char *str) 
{
    return false;
}

bool CFlamingoNgramIndex::Search (const char *str, int kerr, int *numComp,
                          StringList * resList, bool silent)
{
    vector<unsigned> vStrId;

    mpWrap->search(str, kerr, vStrId);

    if (resList) {
        string tmp;

        for (unsigned i = 0; i < vStrId.size(); ++i) {
            mStrContVect.retrieveString(tmp, vStrId[i]);
            resList->push_back(tmp);
        }
    }
    
    return true;
}

bool CFlamingoNgramIndex::SearchInDB (const char *str, int kerr, int *numComp,
                              StringList * resList, bool silent)
{
    cerr << "SearchInDB is not supported.\n";
    return false;
}

bool CFlamingoNgramIndex::OpenDB (const char *name, bool create)
{
    return true;
}

bool CFlamingoNgramIndex::CloseDB ()
{
    return true;
}


bool CFlamingoNgramIndex::DumpDB (const char *name)
{
    ofstream out(name);

    if (!out) {
        string err = string("Cannot create file '") + name + "'";
        Perror(err);
        return false;
    }
    return true;
}

bool CFlamingoNgramIndex::CreateInMemIndex (const char *inputFile, int insertCount, int *dcnt, bool silent)
{
    int    cnt = 0;
    string s;

    ifstream inp(inputFile);

    while (getline(inp, s)) {
        ++cnt;
    }

    if (inp.bad()) {
        Perror("Cannot read from the file: " + string(inputFile));
        return false;
    }

    if (dcnt) *dcnt = cnt;

    mStrContVect.fillContainer(inputFile, cnt);

    mpWrap = new WrapperSimpleEd(&mStrContVect, mpGramGen, true /* use partitioning filter */);

    mpWrap->buildIndex();

    return true;
}

