#ifndef _INDEX
#define _INDEX

#include <stdexcept>

#include "interface.h"
#include "utils.h"
#include "myexcept.h"

#include <wrappers.h>

class CFlamingoNgramIndex : public CInterface {
  public:
    int NgramLen;
   protected:
    GramGenFixedLen         *mpGramGen;
    WrapperSimpleEd         *mpWrap;
    vector<string>          mvList;
    StringContainerVector   mStrContVect;
  public:
    CFlamingoNgramIndex(bool hasTransp, EAlphabet AlphaType);
    virtual ~CFlamingoNgramIndex();
    //=========================================================================
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true);
    //=========================================================================
    bool CreateInMemIndex (const char * inputFile, int insertCount, int * dcnt, bool silent = true);
    virtual bool DumpDB (const char *base_name);
    virtual bool OpenDB (const char *base_name, bool create = false);
    bool CloseDB ();
#ifdef _DEBUG
    void Print (){}
#endif
}

;

#endif
