#ifndef _INDEX
#define _INDEX

#include <stdexcept>

#include "interface.h"
#include "utils.h"
#include "myexcept.h"

#include "common/src/query.h"
#include "common/src/simmetric.h"

#include "ftindexermem.h"
#include "ftsearchermem.h"
#include "ftindexerdiscardlists.h"
#include "ftindexercombinelists.h"
#include "listmerger/src/mergeoptmerger.h"
#include "listmerger/src/scancountmerger.h"

#include "ftindexerondisk.h"
#include "ftsearcherondisk.h"
#include "listmerger/src/ondiskmergersimple.h"
#include "listmerger/src/ondiskmergeradapt.h"


class CFlamingoNgramIndex : public CInterface {
  public:
    int             mNgramLen;
    int             mFanout;
   protected:
    SimMetricEd*            mpSimMetric; 
    GramGenFixedLen         *mpGramGen;
    vector<string>          mvList;
    StringContainerVector   mStrContVect;
    FtIndexerMem<>*         mpIndexer;
    MergeOptMerger<>        mMerger;
    FtSearcherMem<>*        mapSearcher[MAX_KERR + 1];
  public:
    CFlamingoNgramIndex(bool hasTransp, EAlphabet AlphaType);
    virtual ~CFlamingoNgramIndex();
    //=========================================================================
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true);
    //=========================================================================
    bool CreateInMemIndex (const char * inputFile, int insertCount, int * dcnt, bool silent = true);
    virtual bool DumpDB (const char *base_name);
    virtual bool OpenDB (const char *base_name, bool create = false);
    bool CloseDB ();
#ifdef _DEBUG
    void Print (){}
#endif
}

;

#endif
