#!/bin/bash
base=dict
methlist="NgramKdtree NgramKdtreeChunk NgramFreqTries NgramFreqTriesChunk"
METHLIST=$methlist ./check_debug || exit
#./gen_purge_file || exit 1
if [ "$1" = "rus" ] ; then
    export RUSSIAN_ABC=1
else
    unset RUSSIAN_ABC
fi
if [ -z "$RUSSIAN_ABC" ] ; then
    echo "Engilsh tests";
    dict=eng
else
    echo "Russian tests";
    dict=rus
fi
N=$2
if [ -z "$2" ] ; then
    N=1000
fi
if [ ! -z "$3" ] ; then
    methlist=$3
else
    echo -n "" > results
fi
M=8
TestFileFunc=../TestVoc/test${N}_${dict}_func
TestFileBase=../TestVoc/test${N}_${M}
DictFile=../TestVoc/dict${M}_$dict
export SKIP_DISK=1
export SKIP_FUNC_TEST=1
echo "Testfile: N = $N"
for dir in $methlist ; do
  cd $dir
  if [ ! -f indx ] ; then
    echo "$dir is not compiled!"
    exit 1
  fi
  echo "$dir - no transpostions"
  ./indx 0 ../purgeCache "$TestFileFunc" ${TestFileBase}_0_$dict ${TestFileBase}_1_$dict ${TestFileBase}_2_$dict $DictFile
  echo "$dir - with transpositions"
  ./indx 1 ../purgeCache "$TestFileFunc" ${TestFileBase}_0_$dict ${TestFileBase}_1_$dict ${TestFileBase}_2_$dict $DictFile
  if [ -f clear_db.sh ] ; then
	./clear_db.sh
  fi
  cd ..
done
#rm -f purgeCache
mv results results_NgramKdtree
exit 0
