#!/bin/bash
. common_var.sh
echo $DISK_DIR
echo $PURGE_CACHE
base=dict
methlist="SeqAgrepOneChunk SeqAgrep SeqLeven"

METHLIST=$methlist ./check_debug || exit
./gen_purge_file || exit 1
if [ "$1" = "rus" ] ; then
    export RUSSIAN_ABC=1
else
    unset RUSSIAN_ABC
fi
if [ -z "$RUSSIAN_ABC" ] ; then
    echo "Engilsh tests";
    dict=eng
else
    echo "Russian tests";
    dict=rus
fi
N=$2
if [ -z "$2" ] ; then
    N=1000
fi
if [ ! -z "$3" ] ; then
    methlist=$3
else
    echo -n "" > results
fi
DictFile=../TestVoc/dict${M}_$dict
DictList=$DictFile
echo "Testfile: N = $N"
export MAX_DISC_TEST=100
export SKIP_FUNC_TEST=1
TestFileFunc=../TestVoc/test${N}_${dict}_func
dictList=""
for M in 8 ; do
  TestFileBase=../TestVoc/test${N}_${M}
  DictFile=../TestVoc/dict${M}_$dict
  dictList="$dictList ${TestFileBase}_0_$dict ${TestFileBase}_1_$dict ${TestFileBase}_2_$dict $DictFile"
done
export MAX_DISC_TEST=100
export SKIP_FUNC_TEST=1
for dir in $methlist ; do
  . ./run_test.sh $dir "0 1" || exit 1
done
mv results results_SEQ
exit 0
