#!/bin/bash
. common_var.sh
echo $DISK_DIR
echo $PURGE_CACHE
unset SKIP_DISK
base=dict
# Here we select only best versions
methlist="FreqTries Mtree1 NgramMultCompressTransp SeqAgrepOneChunk SignHashOptimizedChunk StringTriesNew StringTriesDouble NgramFreqTriesChunk AlternGenLinHash"
METHLIST=$methlist ./check_debug || exit
./gen_purge_file || exit 1
export RES_FILE="results_disk.eng"
if [ "$1" = "rus" ] ; then
    export RUSSIAN_ABC=1
    export RES_FILE="results_disk.rus"
else
    unset RUSSIAN_ABC
fi
if [ -z "$RUSSIAN_ABC" ] ; then
    echo "Engilsh tests";
    dict=eng
else
    echo "Russian tests";
    dict=rus
fi
N=$2
if [ -z "$2" ] ; then
    N=1000
fi
if [ ! -z "$3" ] ; then
    methlist=$3
else
    echo -n "" > $RES_FILE
fi
if [ ! -z "$4" ] ; then
    dictListSize=$4
else
    dictListSize="8"
fi
M=32
echo "DictList: $dictListSize"
export SKIP_FUNC_TEST=1
TestFileFunc=../TestVoc/test${N}_${dict}_func
dictList=""
for M in $dictListSize ; do
  TestFileBase=../TestVoc/test${N}_${M}
  DictFile=../TestVoc/dict${M}_$dict
  dictList="$dictList ${TestFileBase}_0_$dict ${TestFileBase}_1_$dict ${TestFileBase}_2_$dict $DictFile"
done
echo "Testfile: N = $N"
for dir in $methlist ; do
  . ./run_test.sh $dir "1" || exit 1
done
exit 0
