#!/bin/bash
. common_var.sh
export NO_PURGE_FILE=1
export NO_CLEAR_CACHE=1
export SKIP_FLASH=1
unset FLASH_DIR
echo $DISK_DIR
echo $PURGE_CACHE
base=dict
# Here we select only best version (except AlternGenMorFraenkel & AlternGenIndexExpansion)
methlist="NgramFreqTriesChunk FreqTries Mtree1 NgramMultCompressTransp SeqAgrepOneChunk SignHashOptimizedChunk StringTriesNew StringTriesDouble AlternGenLinHash "
METHLIST=$methlist ./check_debug || exit
./gen_purge_file || exit 1
export RES_FILE="results"
if [ "$1" = "--help" -o "$1" = "-h" ] ; then
   echo "Usage (you can omit any number of arguments in a sequence):"
   echo "$0 <alphabet> <test set size>  <method list> <dict list> <transp list>"
   echo "Default values:"
   echo  "<alphabet> = \"rus eng\""
   echo  "<test set size> = 1000"
   echo  "<method list> = \"$methlist\""
   echo  "<transp list> = \"0 1\""
   exit 0
fi
if [ "$1" = "rus" ] ; then
    export RUSSIAN_ABC=1
    export RES_FILE="results.rus"
else
    unset RUSSIAN_ABC
fi
if [ -z "$RUSSIAN_ABC" ] ; then
    echo "Engilsh tests";
    dict=eng
else
    echo "Russian tests";
    dict=rus
fi
N=$2
if [ -z "$2" ] ; then
    N=1000
fi
if [ ! -z "$3" ] ; then
    methlist=$3
else
    echo -n "" > $RES_FILE
fi
if [ ! -z "$4" ] ; then
    dictListSize=$4
else
    dictListSize="2 4 8 16 32"
fi
if [ ! -z "$5" ] ; then
    transpList=$5
else
    transpList="0 1"
fi
M=32
echo "DictList: $dictListSize"
echo "TranspList: $transpList"
export SKIP_FUNC_TEST=1
TestFileFunc=../TestVoc/test${N}_${dict}_func
dictList=""
for M in $dictListSize ; do
  TestFileBase=../TestVoc/test${N}_${M}
  DictFile=../TestVoc/dict${M}_$dict
  dictList="$dictList ${TestFileBase}_0_$dict ${TestFileBase}_1_$dict ${TestFileBase}_2_$dict $DictFile"
done
echo "Testfile: N = $N"
for dir in $methlist ; do
  . ./run_test.sh "$dir" "$transpList" || exit 1
done
exit 0
