#!/usr/bin/perl -w
my $file = $ARGV[0];
die("Should specify a config file") if !defined($file);

require("$file");

die('Config should specify variable @InputFileList') if !defined(@InputFileList);
die('Config should specify output file prefix $OutputFilePrefix') if !defined($OutputFilePrefix);

my @res = ({}, {});

my %conv = (
    "agrep pipe -x"                                     => ["agrep", 0],
    "nrgrep -x -k..[ids]"                               => ["NRgrep", 0], 
    "nrgrep -x -k..[idst]"                              => ["NRgrep", 1], 
    "myagrepread filter=exact_delayed transp=0"         => ["magrep1", 0],
    "myagrepread filter=exact_delayed transp=1"         => ["magrep1", 1],
    "myagrepread filter=agrep transp=0"                 => ["magrep2", 0],
    "myagrepread filter=agrep transp=1"                 => ["magrep2", 1],
    "lazydfa transp=0"                                  => ["LazyDFA", 0],
    "levendfa transp=0"                                 => ["DFA", 0],
    "levendfa transp=1"                                 => ["DFA", 1],
    "grepmyers transp=0"                                => ["MyersHyyro", 0],
    "grepmyers transp=1"                                => ["MyersHyyro", 1],
);

my $MaxK = 0;

for my $file (@InputFileList) {
    open(FN, "<$file") or die("Canot open '$file'");

    while (<FN>) {
        if (/^K = ([0-9]+) :\s+([0-9\.]+)\s+(.*)$/) {
            my $line = $_;
            my $k  = $1;
            my $tm = $2;
            my $nm = $3;

            $MaxK = $k if ($k > $MaxK);

            my $Transp;
            my $Name;

            if (exists $conv{$nm}) {
                my $c = $conv{$nm};
                $Transp    = $c->[1];
                $Name   = $c->[0];
            } else {
                next;
            }
            defined($Transp) or die("Cannot identify Transp for '$line'");
            defined($Name) or die("Cannot identify Name for '$line'");
            my $ResHashRef = $res[$Transp];

            if (!defined($ResHashRef->{$Name})) {
                $ResHashRef->{$Name} = [];
            }

            my $ResArrRef = $ResHashRef->{$Name};


            #print "$Name -> $Transp ($nm) $tm\n";
            # Choose the minimal value
            if (!defined($ResArrRef->[$k])) {
                $ResArrRef->[$k] = $tm;
            } elsif ($ResArrRef->[$k] > $tm) {
                $ResArrRef->[$k] = $tm;
            }
        }
    }
}

my @TList = (0, 1);
for my $Transp (@TList) {
    my $OutFile = "${OutputFilePrefix}${Transp}.R";
    open FOUT, ">$OutFile" or die("Cannot open '$OutFile' for writing");

    my $ResHashRef = $res[$Transp];

    for my $key (keys(%$ResHashRef)) {
        my $ResArrRef = $ResHashRef->{$key};

        print FOUT "$key <- c(";

        for (my $k = 1; $k <= $MaxK; ++$k) {
            if ($k > 1) { print FOUT "," }
            my $tm = $ResArrRef->[$k]; 
            $tm = "NA" if (!$tm);
            print FOUT "$tm";
        }

        print FOUT ")\n";
    }

    close FOUT;
}
