library(graphics)
library(stats)
library(Hmisc)

Usage <- function(err) {
    print(paste("Error:", err))
    stop("Usage: <InputFile> <OutputFilePrefix>")
}

args <- commandArgs(TRUE)

if (length(args) != 1) {
   Usage("Wrong number of arguments!")
}

source(args[1])

postscript(paste("FullLegend", "eps", sep = "."), family = "Times", encoding = "TeXtext.enc", height=2, width=15, paper="special")

par(cex = 0.8) 
par(font = 1) 

plot.new()
par(mar=c(0,0,0,0))
plot.window(xlim=c(0,100), ylim=c(0,100))

legend(0, 100, legend = Names, col = legendColors, pch = legendSyms, lty = 1, ncol = 4, bty = "n", cex = 1.1)

dev.off()
