#!/bin/bash

TestVocDir=$1

if [ "$1" = "--help" -o "$1" = "-h" -o -z "$1" ] ; then
   echo "Usage (alphabet list and dataset directory are mandatory):"
   echo "$0 <dataset directory> <alphabet list>  <dict list> <method list> <vector size list> <transp list> <q-gram size list>"
fi

if [ -z "$TestVocDir" ] ; then
    echo "You must specify TestVocDir as the first argument!"
    exit 1
fi

if [ ! -d "$TestVocDir" ] ; then
    echo "$TextVocDir is not a directory!"
    exit 1
fi

LangList=$2

if [ -z "$LangList" ] ; then
    echo "You must specify an alphabet as the second argument!"
    exit 1
fi

DictList=$3

if [ -z "$DictList" ] ; then
    DictList=16
fi

MethList=$4

if [ -z "$MethList" ] ; then
    MethList="FreqTriesOptimized SignHashOptimizedChunk NgramFreqTriesChunk"
fi

VectorSizeList=$5

if [ -z "$VectorSizeList" ] ; then
    VectorSizeList="6 7 8 9 10 11 12 13 14 15 16"
fi

TranspList=$6

if [ -z "$TranspList" ] ; then
    TranspList=1
fi

QgramSizeList=$7

if [ -z "$QgramSizeList" ] ; then
    QgramSizeList="2 3"
fi

export SKIP_DISK=1

echo "TestVocDir: $TestVocDir"
echo "VectList:   $VectorSizeList"
echo "LangList:   $LangList"
echo "DictList:   $DictList"
echo "MethList:   $MethList"
echo "TranspList: $TranspList"

for lang in $LangList ; do

    RES_FILE_BASE="results_vect"
    RES_FILE=$RES_FILE_BASE.$lang
    echo > $RES_FILE

    for vl in $VectorSizeList ; do
        export VECTOR_LENGTH=$vl
        echo "Vector size $VECTOR_LENGTH " >> $RES_FILE

        for dir in $MethList ; do 

            if [ "$dir" = "NgramFreqTriesChunk" ] ; then
                for n in $QgramSizeList ; do
                    echo "Ngram len: $n" >> $RES_FILE
                    export NGRAM_LEN=$n
                    ./testSPEED.sh "$TestVocDir" "$lang" 1000 "$dir" "$DictList" "$TranspList" "$RES_FILE_BASE"
                done
            else
                ./testSPEED.sh "$TestVocDir" "$lang" 1000 "$dir" "$DictList" "$TranspList" "$RES_FILE_BASE"
            fi
        done
    done
done
