#!/usr/bin/perl -w
# Merge results for two n-gram implementations: Flamingo and NgramMultCompress
use result;

my $InpFile = $ARGV[0] or die("Specify input file");
my $fd;

open $fd, "<$InpFile" or die("Cannot open '$InpFile' for reading");

my $InfoHashRef = result::ReadFile($fd, {});

for my $key (keys(%$InfoHashRef)) {
    print "$key ";
    my $val = $InfoHashRef->{$key};
    my @RangeN = $val->GetRangeN();

    for (my $i=0; $i <= $#RangeN; ++$i) {
        print "$RangeN[$i] (";
        my @RangeK = $val->GetRangeK($RangeN[$i]);
        for (my $j = 0; $j <= $#RangeK; ++$j) {
            print " " if ($j);
            print "$RangeK[$j]";
        }
        print ") ";
    }

    print "\n";
}
