#!/bin/bash

#1. First do some basic processing of the source files
for d in engnum eng rus dna.11  ; do
#for d in engnum eng rus dna.11 dna.20 ; do
    ./ModResults.pl SourceData/results.$d > SourceData/results_mod.$d
    if [ $? != 0 ] ; then
        echo "ModResults.pl failed"
        exit 2
    fi
done

#2. Create source data R-files
for cnf in Index*Config.pl ; do
    ./CreateTables.pl $cnf 
    if [ $? != 0 ] ; then
        echo "CreateTables.pl failed"
        exit 2
    fi
done

#3. Generate legends
./GenLegends.sh

#4. Draw graphs
for d in eng rus engnum ; do
    Rscript figureTimeSpace.R TableSpaceTimeGraphNL_$d.R ~/Documents/My\ Articles/SISAP2012/Figures/TimeSpace_$d
    if [ $? != 0 ] ; then
        echo "figureTimeSpace.R failed d=$d"
        exit 2
    fi
done
for d in 11 20 ; do
    Rscript figureTimeSpace.R TableSpaceTimeGraphDNA_dna.$d.R ~/Documents/My\ Articles/SISAP2012/Figures/TimeSpace_dna_$d
    if [ $? != 0 ] ; then
        echo "figureTimeSpace.R failed d=$d"
        exit 2
    fi
done


Rscript figureTimeLen.R TableLenTimeGraphClueWeb09.R  ~/Documents/My\ Articles/SISAP2012/Figures/TimeLen_engnum

if [ $? != 0 ] ; then
    echo "figureTimeLen.R failed"
    exit 2
fi

