library(graphics)
library(stats)
library(Hmisc)

Usage <- function(err) {
    print(paste("Error:", err))
    stop("Usage: <InputFile> <OutputFilePrefix> <number of columns> <paper width>")
}

args <- commandArgs(TRUE)

if (length(args) != 4) {
   Usage("Wrong number of arguments!")
}

source(args[1])

postscript(paste(args[2], "eps", sep = "."), family = "Times", encoding = "TeXtext.enc", height=2.5, width=as.integer(args[4]), paper="special")

par(cex = 0.9, cex.lab= 1.4) 
par(font = 1) 

plot.new()
par(mar=c(0,0,0,0))
plot.window(xlim=c(0,20), ylim=c(0,20))

legend(0, 20, legend = Names, col = legendColors, pch = legendSyms, lty = 1, ncol = as.integer(args[3]), 
       bty = "o", cex=1.3)

dev.off()
