package result;

sub new {
    my ($class, $MethName, $HasTransp) = @_;
    my $self = {
        MethName  => $MethName,
        HasTransp => $HasTransp,
        Values    => {}
    };

    bless ($self, $class);
    return $self;
};

sub AddValues {
    my @Input = @_;

    for (my $i = 1; $i <= $#Input; $i++) {
        if ($Input[$i] eq "" or $Input[$i] < 0) {
            $Input[$i] = undef
        }
    }
    my ($self, $N, $kerr, $IndexSize, $TimeMem1, $TimeMem2, $TimeMem3, $TimeMem4, $NumComp1, $NumComp2, $NumComp3, $NumComp4) = @Input;


    ($self->{Values})->{"dict_${N}_$kerr"} = [$IndexSize, $TimeMem1, $TimeMem2, $TimeMem3, $TimeMem4, $NumComp1, $NumComp2, $NumComp3, $NumComp4];

};

sub UniqueNum {
    my @tmp = @_;
    
    my @tmp1 = sort {$a <=> $b} @tmp;
    my @res;
    for (my $i = 0; $i < scalar(@tmp1); ++$i) {
        if (!$i || $tmp1[$i] != $tmp1[$i - 1]) {
            push @res, $tmp1[$i];
        }
    }

    return @res;
}

sub GetRangeN {
    my $self = shift;
    my $val = $self->{Values}; 
    my @tmp;
    for my $k (keys(%$val)) {
        my @parts=split("_", $k); 
        push @tmp, $parts[1];
    }

    return UniqueNum(@tmp);
};

sub GetRangeK {
    my ($self, $N) = @_;

    my $val = $self->{Values}; 
    my @tmp;
    for my $k (keys(%$val)) {
        my @parts=split("_", $k); 
        if ($parts[1] == $N) {
            push @tmp, $parts[2];
        }
    }

    return UniqueNum(@tmp);
}

sub GetValues {
    my ($self, $N, $kerr) = @_;

    if (!$self) {return ();}
    
    my $val = $self->{Values}; 

    my $res = $val->{"dict_${N}_$kerr"};
    if (!$res) {
        print "Undefined values requested for $self->{MethName} (HasTransp = $self->{HasTransp}) N = $N kerr=$kerr\n";
        return ();
    }
    return @{$res};
}

sub SplitKey {
    my @arr =split(/[|]/, shift);

    return {
        MethName  => $arr[0],
        hasTransp => $arr[1]
    };
};

sub RecKey {
    my ($MethName, $HasTransp) = @_;

    return "$MethName|$HasTransp";
}

sub ReadFile {
    my ($fd, $SynHash) = shift;
    my %info = ();

    my $MethName;
    my $HasTransp;
    my $kerr;
    my $ResRef;

    my $LineNum = 1;

    while(<$fd>) {
        chomp;
        my $line = $_;

        if ($line =~ /^([^ ]+)\s+hasTransp=([01])\s+Sigma=([0-9]+)\s+kerr=([0-9]+)/) {
            $MethName  = $1;
            if (exists $SynHash->{$MethName}) {
                $MethName = $SynHash->${MethName};
            }
            $HasTransp = $2;
            $kerr      = $4;
            
            my $k = RecKey($MethName, $HasTransp);
            $ResRef = $info{$k};
            if (!$ResRef) {
                $ResRef =  new result($MethName, $HasTransp);
                $info{$k} = $ResRef;
            }
        } else {
            defined($ResRef) or die("Wrong format, before or in line: $LineNum");
            my ($N, $IndexSize, $tmp1, $TimeMem1, $TimeMem2, $TimeMem3, $TimeMem4, $tmp2, $TimeDisk1, $TimeDisk2, $TimeDisk3, $TimeDisk4, $tmp3, $TimeFlash1, $TimeFlash2, $TimeFlash3, $TimeFlash4, $tmp4, $NumComp1, $NumComp2, $NumComp3, $NumComp4) = split(/\s+/);
            if ($IndexSize < 0) {$IndexSize = 0;}
            if ($MethName eq "FastSS") {
                ;
                #$IndexSize  = $IndexSize * 3.7; # Empirically determined constant
                $IndexSize  = $IndexSize * 2; # Empirically determined constant
            }
            defined($kerr) or die("kerr is not defined, line: $LineNum");
            $ResRef->AddValues($N, $kerr, $IndexSize, $TimeMem1, $TimeMem2, $TimeMem3, $TimeMem4, $NumComp1, $NumComp2, $NumComp3, $NumComp4);
        }
        ++$LineNum;
    }

    return \%info;
}

1;
