#!/bin/bash

TestNumLarge=10000
#TestNumSmall=1000
TestNumSmall=10000

MethListMF="AlternGenMorFrankPerfHashCompDNA FastSS"
MethListLarge="StringTriesDouble"
MethListSmall="NgramMultCompress NgramFlamingo FreqTries AlternGenLinHash" 

for lang in dna ; do

    TestDir="TestVocDNA"
    config="config.dna"

    RES_FILE="results.${lang}"

    for l in 11 ; do
    #for l in 20 11 ; do
        rm -f $RES_FILE
        TestNum1=10000

        for d in 2 4 8 16 32 ; do
           if [ $l = 11 ] ; then
                if [ $d -ge 4 ] ; then
                    MAX_KERR_MF=2
                else 
                    MAX_KERR_MF=3
                fi

            elif [ $l = 20 ] ; then
                if [ $d -ge 4 ] ; then
                    MAX_KERR_MF=2
                else
                    MAX_KERR_MF=3
                fi
            else
                echo "Echo unsupported length: $l"
                exit 1
            fi

            for meth in $MethListMF ; do
                k=1
                while [ $k -le $MAX_KERR_MF ] ; do
                    export MAX_KERR=$k
                    ./testSPEED.sh "$TestDir" "$lang" "$TestNumLarge" "$meth" "$d.$l" 0 results "$config"
                    k=$(($k+1))
                done
            done

            for meth in $MethListLarge ; do
                export MAX_KERR=4
                ./testSPEED.sh "$TestDir" "$lang" "$TestNumLarge" "$meth" "$d.$l" 0 results "$config"
            done

            for meth in $MethListSmall ; do
                export MAX_KERR=4
                ./testSPEED.sh "$TestDir" "$lang" "$TestNumSmall" "$meth" "$d.$l" 0 results "$config"
            done
        done

        cat $RES_FILE >> "${RES_FILE}.$l"
    done

done

MethListMF="AlternGenMorFrankPerfHashCompOth AlternGenReducedAlphaMorFrankPerfHashCompact2 FastSS"
MethListLarge="StringTriesDouble"
MethListSmall="NgramMultCompress NgramFlamingo AlternGenReducedAlpha FreqTries" 

for lang in engnum eng ; do
#for lang in engnum eng rus ; do
    TestDir=""
    config=""
    if [ $lang = "engnum" ] ; then
        TestDir="TestVocCLUEWEB09"
        config="config.clueweb09"
    fi

    if [ $lang = "eng" -o $lang = "rus" ] ; then
        TestDir="TestVoc"
        config="config.engrus"
    fi

    if [ "$TestDir" = "" ] ; then
        echo "TestDir is not defined for lang = $lang"
        exit 2
    fi

    rm -f results.$lang


    for d in 2 4 8 16 32 ; do
        if [ $d -gt 16 ] ; then
            MAX_KERR_MF=2
        elif [ $d -gt 4 ] ; then
            MAX_KERR_MF=3
        else
            MAX_KERR_MF=4
        fi

        for meth in $MethListMF ; do
            k=1
            while [ $k -le $MAX_KERR_MF ] ; do
                export MAX_KERR=$k
                ./testSPEED.sh "$TestDir" "$lang" "$TestNumLarge" "$meth" "$d" 0 results "$config"
                k=$(($k+1))
            done
        done
 
        for meth in $MethListLarge ; do
            export MAX_KERR=4
            ./testSPEED.sh "$TestDir" "$lang" "$TestNumLarge" "$meth" "$d" 0 results "$config"
        done

        for meth in $MethListSmall ; do
            export MAX_KERR=4
            ./testSPEED.sh "$TestDir" "$lang" "$TestNumSmall" "$meth" "$d" 0 results "$config"
        done
    done
done


