#!/bin/bash
TestFileSize=10000


RES_FILE_BASE="results"

ConfFile=""

M=2

MethList="FastSS StringTriesDouble AlternGenMorFrankPerfHashCompOth AlternGenReducedAlphaMorFrankPerfHashCompact2"

for lang in engnum ; do
    Len="4"
    while [ "$Len" != "16" ] ; do
        RES_FILE="results.${lang}"
        TestDir=""
        config=""
        if [ $lang = "engnum" ] ; then
            TestDir="TestVocCLUEWEB09"
            config="config.clueweb09"
        fi

        if [ $lang = "eng" -o $lang = "rus" ] ; then
            TestDir="TestVoc"
            config="config.engrus"
        fi

        if [ "$TestDir" = "" ] ; then
            echo "TestDir is not defined for lang = $lang"
            exit 2
        fi

        rm -f $RES_FILE

        DictList="${M}.${Len}"
        DictSyn="$TestDir/dict${M}.${Len}_${lang}"
        rm -f $DictSyn
        # Create a temporary dictionary synonym
        ln -s "$PWD/$TestDir/dict${M}_${lang}" $DictSyn

        echo $DictList
        # Searching with transpositions here
        for m in $MethList ; do
            if [ $m = "FastSS"  ] ; then
                export MAX_KERR=3 
            else
                export MAX_KERR=4 
            fi
            ./testSPEED.sh $TestDir $lang $TestFileSize "$m" "$DictList" "0" "$RES_FILE_BASE" "$config"
        done

        cat $RES_FILE >> "${RES_FILE}.$Len"

        
        Len=$(($Len + 1))

        # This is a temporary link
        rm -f $DictSyn
    done
done

MethList="FastSS StringTriesDouble AlternGenMorFrankPerfHashCompDNA"

for lang in dna ; do
    Len="12"
    while [ "$Len" != "20" ] ; do
        RES_FILE="results.${lang}"

        TestDir="TestVocDNA"
        config="config.dna"

        if [ "$TestDir" = "" ] ; then
            echo "TestDir is not defined for lang = $lang"
            exit 2
        fi

        rm -f $RES_FILE

        DictList="${M}.${Len}"
        DictSyn="$TestDir/dict${M}.${Len}_${lang}"
    
        echo $DictList
        # Searching with transpositions here
        for m in $MethList ; do
            if [ $m = "FastSS"  ] ; then
                export MAX_KERR=3 
            else
                export MAX_KERR=4 
            fi
            ./testSPEED.sh $TestDir $lang $TestFileSize "$m" "$DictList" "0" "$RES_FILE_BASE" "$config"

            if [ $m = "FastSS"  ] ; then
                export MAX_KERR=2 
            else
                export MAX_KERR=3 
            fi
            ./testSPEED.sh $TestDir $lang $TestFileSize "$m" "$DictList" "0" "$RES_FILE_BASE" "$config"
        done

        cat $RES_FILE >> "${RES_FILE}.$Len"

        
        Len=$(($Len + 1))
    done
done

exit 0
