#ifndef _INDEX_LEVENDFA_H 
#define _INDEX_LEVENDFA_H

#include "interface.h"
#include "utils.h"
#include "levendfa.h"

class CLevenDFAIndex : public CInterface {
    static const int bufsize = 64 * 1024;
    static const int MaxLen = 2048;
  protected:
    vector <string>   wordList;
    string   Name;
    int      recNum;
    int      cntFnd;
    void     ClearMem ();
    bool     opened;
    int      fd;
    const    static char termChar;
    DECLARE_STATIC_COUNTER(cr_dfa)
  public:
     CLevenDFAIndex (bool hasTransp, EAlphabet AlphaType);
     virtual ~ CLevenDFAIndex ();

    //=========================================================================
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool DumpDB (const char *file_name);
    virtual bool OpenDB (const char *file_name, bool create = false);
    virtual bool CloseDB ();
    void PrintAddStat(SearchType type, int testNum, int kerr, ostream &ostr);
    void ResetCounters();
};

#endif
