#include "rstat.h"
#include <fstream>
#include "langcase.h"

using namespace std;

bool CollectStat::CollectFileStat (const char *fname)
{
    double mp[256];
    for (int i = 0; i < 256; i++)
        mp[i] = 0;
    unsigned char c;
    int cnt = 1;
    ifstream fin (fname);
    if (!fin)
        return false;
    for (fin >> c; !fin.eof (); fin >> c)
        if (isalpha_eng_rus (c)) {
            mp[uchar (toupper_eng_rus (c))]++;
            cnt++;
        }
    vf.clear ();
    vf.reserve (128);
    for (int i = 0; i < 256; i++)
        if (mp[i] >= 0.5)
            vf.insert (vf.end (), freqpair (mp[i] / cnt, char (i)));
    return true;
};

void CollectStat::CollectStringStat(const vector<string> & StrList)
{
    double mp[256];
    for (int i = 0; i < 256; i++)
        mp[i] = 0;
    unsigned char c;
    int cnt = 1;
        
    for (int k = 0; k < StrList.size(); ++k) {
        for (int i = 0; i < StrList[k].size(); ++i) {
            c = StrList[k][i];
            if (isalpha_eng_rus (c)) {
                mp[uchar (toupper_eng_rus (c))]++;
                cnt++;
            }
        }
    }

    vf.clear ();
    vf.reserve (128);
    for (int i = 0; i < 256; i++)
        if (mp[i] >= 0.5)
            vf.insert (vf.end (), freqpair (mp[i] / cnt, char (i)));
}
