#ifndef _EDIST_K
#define _EDIST_K

#include <algorithm>
#include <iostream>

/*

  Note this class is not designed to be used in multi-thread environment

*/

class distCol {
    static unsigned int m_dummy;
    int m_kerr;
    int m_lo;
    int m_hi;
    int m_pos;
    unsigned int *m_pCol;
    inline void allocMem ();
    inline void freeMem ();
    inline int realIndex (unsigned int i);
    inline void copyContent (const distCol &);
    inline unsigned int size ();
  public:
     inline distCol (int pos, unsigned int kerr);
    inline distCol (const distCol &);
     inline ~ distCol ();
    inline const distCol & operator= (const distCol &);
    inline unsigned int &getElem (unsigned int i);
    inline bool noCutoff (int upperIndex, bool hasTransp);
};

class checkDistContext {
    unsigned int m_kerr;
    int m_pos;
    unsigned int m_patSize;
    const char *m_pStr;
    unsigned int m_currCol;
    distCol *m_apCol[2];
    inline void freeMem ();
    inline void copyContent (const checkDistContext & src);
  public:
     checkDistContext (unsigned int kerr, const char *str);
     checkDistContext (const checkDistContext &);
    const checkDistContext & operator= (const checkDistContext & src);
    ~checkDistContext ();
/* 
   If complete is not true we are just in progress comparing word prefixes.
   In this case checkDist return false if and only if both current and previous 
   computed columns contain not values <= kerr
*/
    bool checkDist (const char *str, bool complete, bool hasTransp);
    bool checkDist (const char *str, unsigned int len, bool complete, bool hasTransp, int *dist);
    unsigned int getKerr() const {return m_kerr;}
    void Print (void);
};
#endif
