#ifndef _INDEXDFA_H
#define _INDEXDFA_H
#include "triedfa.h"
#include "interface.h"

class CTrieIndexDFA : public CInterface {
  protected:
    CTrieDFA node;
  public:
    CTrieIndexDFA (bool hasTransp, EAlphabet AlphaType);
    virtual ~CTrieIndexDFA ();
    bool opened;
    int fd;

    //=========================================================================
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool DumpDB (const char *file_name);
    virtual bool OpenDB (const char *file_name, bool create = false);
    virtual bool CloseDB ();
    virtual void PrintAddStat(SearchType type, int testNum, int kerr, ostream & ostr);
    void ResetCounters() {node.ResetCounters();}
#ifdef _DEBUG
    void Print ();
#endif
};

#endif
