#ifndef _INDEX_DFA_DOUBLE_H
#define _INDEX_DFA_DOUBLE_H
#include "triedfa.h"
#include "interface.h"

class CTrieIndexDFADouble : public CInterface {
  protected:
    CTrieDFA nodeFwd; // Usual dictionary
    CTrieDFA nodeRev; // Reverse dictionary
  public:
    CTrieIndexDFADouble(bool hasTransp, EAlphabet AlphaType);
    virtual ~CTrieIndexDFADouble();
    bool opened;
    int fdFwd;
    int fdRev;

    DECLARE_COUNTER(stime)
    DECLARE_COUNTER(lproc)
    //=========================================================================
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool DumpDB (const char *file_name);
    virtual bool OpenDB (const char *file_name, bool create = false);
    virtual bool CloseDB ();
    virtual void PrintAddStat(SearchType type, int testNum, int kerr, ostream & ostr);
    void ResetCounters() {
        nodeFwd.ResetCounters();
        nodeRev.ResetCounters();
        RESET_COUNTER(stime);
        RESET_COUNTER(lproc);
    }
#ifdef _DEBUG
    void Print ();
#endif
};

#endif
