#ifndef _INDEX_H
#define _INDEX_H
#include "trie.h"
#include "interface.h"

class CTrieIndex : public CInterface {
  protected:
    CTrie nodeFwd; // Usual dictionary
    CTrie nodeRev; // Reverse dictionary
  public:
    CTrieIndex (bool hasTransp, EAlphabet AlphaType);
    virtual ~CTrieIndex ();
    bool opened;
    int fdFwd;
    int fdRev;

    //=========================================================================
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool DumpDB (const char *file_name);
    virtual bool OpenDB (const char *file_name, bool create = false);
    virtual bool CloseDB ();
#ifdef _DEBUG
    void Print ();
#endif
};

#endif
