#include "afuzzycontext.h"

context::context():k(0), 
                    /*R (NULL), RP (NULL), */
                    cnt (0), cntp(0), startpos (0),
                    hasTransp(false)
{
};

void context::init(int _k, bool _hasTransp)
{
    k = _k;
    hasTransp = _hasTransp;
    /*
    R = new Uint[k + 1];
    if (hasTransp) RP = new Uint[k + 1];
    */
    cnt = cntp = startpos = 0;
#ifdef STRICTER_CUTOFF
    Mask = (1 << (k + 1)) - 1;
    MaskP = 0; 
#endif
}

context::~context ()
{
    /*
    delete [] RP;
    delete [] R;
    */
}


afuzzycontext::afuzzycontext ():S (NULL)/*, R1 (NULL), RI (NULL)*/
{;
}

void afuzzycontext::init(const std::string & p, int kerr, bool _hasTransp, context * cntx)
{
    k = kerr;
    hasTransp = _hasTransp;
    m = p.length ();
    mask_ok = 1 << (m - 1);
    memset (Map, 0, sizeof (Map));
    memset (SMapArr, 0, sizeof (SMapArr));

    delete[]S;
    //delete[]R1;
    //delete[]RI;

    S = new Uint[m + 1];
    //R1 = new Uint[k + 1];
    //RI = new Uint[k + 1];
    cntx->init(k, hasTransp);
    S[0] = 0;
    cntx->R[0] = 0;
    if (hasTransp) cntx->RP[0] = 0;
    cntx->cnt = cntx->cntp = 0;
    RI[0] = 0;
    for (int i = 0, cnt = 0; i < m; i++) {
        int l = Map[(unsigned char) p[i]];
        if (!l) {
            l = Map[(unsigned char) p[i]] = ++cnt;
            S[l] = 0;
        }
        S[l] |= 1 << i;
    }
    // precompute S[Map[c]] for faster evaluation
    for (unsigned int c = 0; c <= 255; ++c)
        SMapArr[c] = S[Map[c]];


    for (int d = 0; d <= k; d++)
        RI[d] = (1 << d) - 1;

    r_size = sizeof (Uint) * (k + 1);
    // set initial values for cntx
    memcpy (cntx->R, RI, r_size);   // R = RI
    cntx->cnt = 0;
}

afuzzycontext::~afuzzycontext ()
{
    delete[]S;
    //delete[]R1;
    //delete[]RI;
}

