
#ifndef AFUZREG_H
#define AFUZREG_H
/*
 Author: Leonid Boitsov
 Date  : Summer 2000
 This file could be freely distributed under the terms of GPL
*/

#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "uint.h"

const char WildCard = '%';
const char AnyChar = '_';
const char LeftBracket = '[';
const char RightBracket = ']';
const char RangeChar = '-';
const char SpecChar = '\\';
const char MinChar = ' ';

#define IsLatinUpper(c) ( ((unsigned char)c)>=((unsigned char)'A') && ((unsigned char)c) <=((unsigned char)'Z') )
#define IsLatinLower(c) ( ((unsigned char)c)>=((unsigned char)'a') && ((unsigned char)c) <=((unsigned char)'z') )
#define IsLatinChar(c)  ( IsLatinUpper(c) || IsLatinLower(c) )



class afuzreg {
  protected:
    enum State { Normal = 0, AfterLeftBracket = 1, AfterRangeChar = 2 };
    int cnt;
    Uint *R, *R1, *S, *RI, *RP;
    Uint SLeftMostWild, SWild, SAny;
    int Map[256];
    int k;
    int m;                      // Corrected size of the pattern
    // Every expression with brackets like [aB...] 
    // is count as one char as well as wildcard (%)
    // and any character symbol (_)
    Uint mask_ok;
    int r_size;
    bool IgnoreCase;

    bool ParseReg (const char *p, char *ErrStr, int ErrLen);
    char CurrChar (bool * NoSpec, const char *);
    char NextChar (bool * NoSpec, const char *);    // *NoSpec true if the char foolows '\'
    void ToNextChar (const char *);
    int patcnt;
    void FreeMem ();
  public:

     afuzreg ();
    bool init (const char *p, int errnum, char *ErrStr, int ErrLen,
               bool ignorecase);
     virtual ~ afuzreg ();

    bool checkREG (const char *t) const;
    static int MaxPatSize () {
        return sizeof (Uint) * 8;
}};


#endif
