#ifndef AFUZZY_H
#define AFUZZY_H

/*
  Leonid Boitsov 2002
  This code is a GPL software and is distributed under GNU
  public licence without any warranty.
 */

#include <string.h>
#include "uint.h"


class afuzzy {
    int cnt;
    Uint *R, *R1, *RP, *S, *RI;
    Uint *FilterS;
    unsigned int Map[256];
    unsigned int FilterMap[256];
    unsigned int k;
    unsigned int m;
    Uint mask_ok;
    Uint filter_ok;
    Uint filter_shift;
    unsigned int r_size;
    bool FilterSet; // filter is not used for record-to-record comparisons
    unsigned char PatFilter[sizeof (Uint) * 8 + 1];

    bool mHasTransp; 
  public:
    afuzzy (bool hasTransp); // hasTransp only has effect with checkRTR
    // fitler is not used for RTR comparsions
    void init (const char *p, unsigned int k, bool UseFilter = true);
    bool checkRTR (const char *t, unsigned int n) const;
    bool checkRTR (const char *t, unsigned int *dist =
                   NULL, char term_char = 0) const;
    bool checkSUB (const char *t, unsigned int n) const;
    bool checkSUB (const char *t, char term_char = 0) const;
    bool checkFLT (const char *t, unsigned int n) const;
    bool checkFLTterm (const char *t, char term_char = 0) const;
    ~afuzzy ();
    static unsigned int MaxPatSize () { return sizeof (Uint) * 8; }
};


#endif
