#include "myers.hpp"

unsigned int CalcDistGlob(const unsigned char* p, bool HasTransp, unsigned int PatLen, MaskType Checker, MaskType VP0, MaskType PMText[])
{
    unsigned int dist = PatLen;

    MaskType    VP = VP0,
                VN = 0,
                HP = 0,
                HN = 0,
                D0 = 0,
                PrevPM = 0;

    if (!HasTransp) {
        for (;*p; ++p) {
            MaskType PM = PMText[*p];

            D0 = (( (PM & VP) + VP) ^ VP) | PM | VN;

            HP = VN | ~( D0 | VP );
            HN = D0 & VP;

            if (HP & Checker) ++dist;
            else if (HN & Checker) --dist;

            MaskType HPShift = (HP << 1) | 1;

            VP = (HN << 1) | ~( D0 | HPShift ); 
            VN = D0 & HPShift;
        }
    } else {
        for (;*p; ++p) {
            MaskType PM = PMText[*p];
            MaskType TR = ( ((~D0) & PM) << 1 ) & PrevPM;
            PrevPM = PM;

            D0 = (( (PM & VP) + VP) ^ VP) | PM | VN | TR;

            HP = VN | ~( D0 | VP );
            HN = D0 & VP;

            if (HP & Checker) ++dist;
            else if (HN & Checker) --dist;

            MaskType HPShift = (HP << 1) | 1;

            VP = (HN << 1) | ~( D0 | HPShift ); 
            VN = D0 & HPShift;
        }
    }

    return dist;
}
