
if [ "$1" = "--help" -o "$1" = "-h" -o -z "$1" ] ; then
   echo "Usage:"
   echo "$0 <dataset directory> <alphabet code> <test set size>  <method list> <dictionary list> <transposition-awareness list> <result file prefix> <method config file>"
   echo "=================================================================================="
   echo  "NOTE1: alphabet code and dataset directory (one of the TestVoc* dirs) are mandatory"
   echo "=================================================================================="
   echo  "NOTE2: that only the following combinations of dataset directories and language codes are valid:"
   echo  "<dataset directory>=TestVoc <alphabet code>=eng"
   echo  "<dataset directory>=TestVoc <alphabet code>=rus"
   echo  "<dataset directory>=TestVocCLUEWEB09 <alphabet code>=engnum"
   echo  "<dataset directory>=TestVocDNA <alphabet code>=dna"
   echo "=================================================================================="
   echo "NOTE3: Default parameter values:"
   echo  "<test set size> = 1000"
   echo  "<method list> = \"$methlist\""
   echo  "<dictionary list> = \"2 4 8 16 32\""
   echo  "<transposition-awareness list> = \"0 1\""
   exit 0
fi

TestVocDir=$1

if [ -z "$TestVocDir" ] ; then
    echo "Directory that contains test/dictionary files is empty!"
    exit 1
fi

if [ ! -d "$TestVocDir" ] ; then
    echo "'$TextVocDir' is not a directory that contains test/dictionary files!"
    exit 1
fi

N=$3
if [ -z "$3" ] ; then
    N=1000
fi
if [ ! -z "$4" ] ; then
    methlist=$4
fi
if [ ! -z "$5" ] ; then
    dictListSize=$5
else
    dictListSize="2 4 8 16 32"
fi
if [ ! -z "$6" ] ; then
    transpList=$6
else
    transpList="0 1"
fi

if [ ! -z "$7" ] ; then
    export RES_FILE_BASE="$7"
else
    export RES_FILE_BASE=results
fi

Config=$8

if [ -z "$Config" ] ; then
    Config=$EnvVarConfig
fi

if [ ! -z "$Config" -a ! -f "$Config" ] ; then
    echo "'$Config' File not found"
    exit 4
fi

echo "Config file:  $Config"

echo "DictList: $dictListSize"
echo "TranspList: $transpList"
TestFileFunc=../TestVoc/test${N}_${dict}_func

. common_param_lang.sh
