#!/bin/bash
wget http://www.dcc.uchile.cl/~gnavarro/software/nrgrep.tar.gz
if [ "$?" != 0 ] ; then
    echo "Cannot download nrgrep archive!"
    exit 1
fi
tar -zxvf nrgrep.tar.gz
if [ "$?" != 0 ] ; then
    echo "Cannot decompress nrgrep archive!"
    exit 1
fi
ND="nrgrep-1.1.2"
if [ ! -d "$ND" ] ; then
    echo "Cannot find directory $ND after decompressing nrgrep archive, perhaps, NR-grep version has changed. Please download version 1.1.2"
fi
wget ftp://ftp.cs.arizona.edu/agrep/agrep-2.04.tar
if [ "$?" != 0 ] ; then
    echo "Cannot download agrep archive!"
    exit 1
fi
tar -xvf agrep-2.04.tar
if [ "$?" != 0 ] ; then
    echo "Cannot decompress agrep archive"
    exit 1
fi
AD="agrep-2.04"
if [ ! -d "$ND" ] ; then
    echo "Cannot find directory $ND after decompressing agrep archive, perhaps, agrep version has changed. Please download version 2.04"
fi
