#include <iostream>
#include <fstream>
#include <algorithm>

using namespace std;

void usage(const char *pName) {
    cerr << "Generation of complete dictionaries\n";
    cerr << "Usage: " << pName << " <Number of alphabet chars> <Words' Length>\n";
}

int main(int argc, char *pArgv[]) {
    if (argc != 3) {
        usage(pArgv[0]);
        return 1;
    }
    int Sigma = atol(pArgv[1]);
    int len   = atol(pArgv[2]);
    if (Sigma < 1 || Sigma > 'z' - 'a' + 1) {
        cerr << "Wrong alphabet size (" << Sigma << ")\n";
        return 1;
    }
    if (len < 1) {
        cerr << "Wrong length size (" << len << ")\n";
    }

    char first = 'a';
    char last = first + Sigma - 1;
    char str[len + 1];

    fill(str, str + len, first);
    str[len] = 0;

    while (1) {
        cout << str << endl; 
        if (str[len - 1] < last) {str[len - 1]++;}
        else {
            int cur1 = len - 1;

            for (; cur1 >= 0 && str[cur1] == last; --cur1) {
                str[cur1] = first;
            }
            if (cur1 < 0) {break;}
            str[cur1]++;
        }
    }
    return 0;
}
