#!/bin/bash
export RES_FILE_BASE=results_func

export SKIP_DISK=1

if [ "$1"  = "" -o "$1" = "--help" -o "$1" = "-h" ] ; then
   echo "Usage (dataset directory and alphabet are mandatory):"
   echo "$0 <dataset directory> <alphabet> <test set size>  <method list> <transp list> "
   echo "Default values:"
   echo  "<test set size> = 5000"
   echo  "<method list> = ""$methlist"
   echo  "<transp list> = \"0\""
   exit 0
fi

TestVocDir=$1

. common_param_lang.sh

N=$3

if [ -z "$3" ] ; then
    N=5000
fi

if [ ! -z "$4" ] ; then
    methlist=$4
    echo "Testing selected methods:  $methlist"
else
    . ./mainlist.sh
    methlist="$methlist AlternGenIndexExpansion AlternGenIndexExpansion2 AlternGenMorFrank AlternGenReducedAlpha AlternGenSuperCond"
    echo -n "" > results
    echo "Testing only main methods (except Cole_et_al):  $methlist"
    
    echo -n "" > results
fi

methlist=$methlist ./check_debug || exit

if [ ! -z "$5" ] ; then
    transpList=$5
else
    transpList="0 1"
fi

M=32

export NO_CLEAR_CACHE=1

TestFileFunc=../$TestVocDir/test${N}_${dict}_func

echo "Transp list: $transpList"

for dir in $methlist ; do
  pushd $dir
  if [ ! -f indx ] ; then
    echo "$dir is not compiled!"
    exit 1
  fi
  for transp in $transpList ; do
  if [ $transp = "0" ] ; then
      echo "$dir - no transpositions"
    else
      echo "$dir - with transpositions"
    fi
  
    echo ./indx $transp ../purgeCache "$TestFileFunc"
    ./indx $transp ../purgeCache "$TestFileFunc"
    if [ -f clear_db.sh ] ; then
    	./clear_db.sh
    fi
  done
  popd
done
exit 0
